unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, HotKeyManager;

type
  TMainForm = class(TForm)
    Label1: TLabel;
    HotKey1: THotKey;
    BtnTest: TButton;
    BtnAdd: TButton;
    BtnClear: TButton;
    BtnExit: TButton;
    ListBox1: TListBox;
    BtnRemove: TButton;
    Label2: TLabel;
    Label3: TLabel;
    HotKeyManager1: THotKeyManager;
    procedure BtnAddClick(Sender: TObject);
    procedure BtnRemoveClick(Sender: TObject);
    procedure BtnClearClick(Sender: TObject);
    procedure BtnTestClick(Sender: TObject);
    procedure BtnExitClick(Sender: TObject);
    procedure HotKeyManager1HotKeyPressed(HotKey: TShortCut; Index: Word);
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

type
  THotKeyEntry = class
    HotKey: TShortCut;
    constructor Create(iHotKey: TShortCut);
  end;

constructor THotKeyEntry.Create(iHotKey: TShortCut);
begin
  inherited Create;
  HotKey := iHotKey;
end;

{--------------------- TMainForm ----------------------}

procedure TMainForm.BtnAddClick(Sender: TObject);
var
  HotKeyVar: TShortcut;
begin
  HotKeyVar := HotKey1.HotKey;
  if HotKeyVar = 0 then
    MessageDlg('No hotkey is specified.', mtWarning, [mbOk], 0)
  else
  begin
    if HotKeyManager1.AddHotKey(HotKeyVar) <> 0 then
    begin
      ListBox1.Items.AddObject(ShortCutToText(HotKeyVar), THotKeyEntry.Create(HotKeyVar));
      HotKey1.HotKey := 0;
    end
    else
      MessageDlg(ShortCutToText(HotKeyVar) + ' couldn''t be assigned to a hotkey.',
        mtWarning, [mbOk], 0);
  end;
end;


procedure TMainForm.BtnRemoveClick(Sender: TObject);
var
  HotKeyEntry: THotKeyEntry;
begin
  if ListBox1.ItemIndex > -1 then
  begin
    HotKeyEntry := (ListBox1.Items.Objects[ListBox1.ItemIndex] as THotKeyEntry);
    if HotKeyManager1.RemoveHotKey(HotKeyEntry.HotKey) then
    begin
      HotKeyEntry.Free;
      ListBox1.Items.Delete(ListBox1.ItemIndex);
    end
    else
      MessageDlg(ShortCutToText(HotKeyEntry.HotKey) + ' couldn''t be removed.',
        mtWarning, [mbOk], 0);
  end;
end;


procedure TMainForm.BtnClearClick(Sender: TObject);
var
  I: Integer;
begin
  HotKeyManager1.ClearHotKeys;
  HotKey1.HotKey := 0;
  for I := 0 to ListBox1.Items.Count -1 do
    (ListBox1.Items.Objects[I] as THotKeyEntry).Free;
  ListBox1.Items.Clear;
end;


{ This method will always return "not available". It is included for illustrative
  purposes. It would make more sense to use the method BEFORE the hotkey is
  actually added. }

procedure TMainForm.BtnTestClick(Sender: TObject);
var
  HotKey: TShortCut;
  S1: String;
begin
  if ListBox1.ItemIndex > -1 then
  begin
    HotKey := (ListBox1.Items.Objects[ListBox1.ItemIndex] as THotKeyEntry).HotKey;
    S1 := '';
    if not HotKeyAvailable(HotKey) then
      S1 := 'not ';
    MessageDlg(ShortCutToText(HotKey) + ' is ' + S1 + 'available for registration.',
               mtInformation, [mbOk], 0);
  end;
end;


procedure TMainForm.BtnExitClick(Sender: TObject);
begin
  Close;
end;


procedure TMainForm.HotKeyManager1HotKeyPressed(HotKey: TShortCut; Index: Word);
begin
  SetForegroundWindow(Application.Handle);
  MessageDlg('Hotkey ' + ShortCutToText(HotKey) + ' pressed.', mtInformation, [mbOk], 0);
end;

end.

